<?php
class HelperHtml {

	public static function actionButtonByJavascript($img, $id, $options, $tab = "") {
		$button = "$tab<a class='popup_download' onclick=\"deleteById('$id', '{$options['action-delete']}', '{$options['m']}', '{$options['script-delete']}', '". constant($options['msg-delete']) ."');\">\n"
						.	"$tab\t<img src='./includes/images/$img.png' onmouseover=\"Tip('". constant($options['btn-delete']) ."')\" onmouseout='UnTip()'>\n"
						. "$tab</a>\n";
		return $button;
	}

	public static function actionButtonByModal($img, $url, $modal, $tooltip, $tab = "") { 
		$button =	"$tab<a href='$url' data-remote='false' data-toggle='modal' data-target='#$modal' class='popup_download'>\n"
						. "$tab\t<img src='./includes/images/$img.png' onmouseover=\"Tip('". constant($tooltip) ."')\" onmouseout='UnTip()'>\n"
						. "$tab</a>&nbsp\n";
		return $button;
	}

	public static function buildTabs($id, $msg, $menu, $content, $tab = "") {
		$tabs = "$tab<script>\n"
					. "$tab\t$(function() {\n"
					. "$tab\t\t$('#$id').tabs({active:0});\n"
					. "$tab\t});\n"
					. "$tab</script>\n"
					. $msg
					. "$tab<!-- BEGIN TABS --!>\n"
					. "$tab<div id='tabs' style='margin-top:20px;'>\n"
					. "$tab\t<ul>\n"
					. $menu
					. "$tab\t</ul>\n"
					. $content
					. "$tab</div>\n"
					. "$tab<!-- END TABS --!>\n";
		return $tabs;
	}

	public static function dynamicTable($header, $datas, $options, $tab = "") {
		$id = $options['checkall-id'];
		$table = 	"$tab<div class='container table-responsive' style='{$options['table-style']}'>\n"
						. "$tab\t<table class='table table-striped table-bordered'>\n"
						. "$tab\t\t<thead><tr><th class='checkall'><div data-toggle='tooltip' title='Check all'><input type='checkbox' id='$id'></div></th><th>". implode('</th><th>', $header) ."</th></tr></thead>\n";
		if (!empty($datas)) {
			$table .= "$tab\t\t<tbody>\n";
			foreach ($datas as $id => $data) {
				$table .= "$tab\t\t\t<tr>\n"
								.	"$tab\t\t\t\t<td class='checkall'><form><input type='checkbox' name='entryid' class='entryid {$options['action-delete']}' value1='$id' value2='". (isset($data['name']) ? $data['name'] : '') ."'></form></td>\n"
								. "$tab\t\t\t\t<td>". implode('</td><td>', $data) ."</td>\n"
								. "$tab\t\t\t\t<td>\n"
								. self::actionButtonByModal('modify', "{$options['url-edit']}&id=$id", $options['modal-id'], $options['btn-modify'], "$tab\t\t\t\t\t")
								. (isset($options['btn-copy']) ? self::actionButtonByModal('copy', "{$options['url-edit']}?id=$i&copy=1", $options['modal-id'], $options['btn-copy'], "$tab\t\t\t\t\t") : '')
								. self::actionButtonByJavascript('delete', $id, $options, "$tab\t\t\t\t\t")
								.	"$tab\t\t\t\t</td>\n"
								. "$tab\t\t\t</tr>\n";
			}
			$table .= "$tab\t\t</tbody>\n";
		}
		$table .= "$tab\t</table>\n"
						. "$tab\t<img src='./includes/images/arrow.jpg' style='margin-left:10px;margin-right:5px;'><a href=\"javascript:void deleteAll('{$options['action-delete']}', '{$options['m']}', '{$options['script-delete']}', '". constant($options['msg-delete']) ."');\">". constant($options['btn-delete-all']) ."</a>\n"
						.	"$tab</div>\n"
						. self::modalButton($options, $tab)
						. self::dynamicTableJavascript($options);
		return $table;
	}

	public static function dynamicTableJavascript($options) {
		ob_start();
		?>
		<script>
			$('#<?php echo $options['checkall-id']; ?>').click(function() {
				var checkall = this.checked;
				$('.entryid').each(function() {
					this.checked = checkall;
				});
			});
		</script>
		<?php
		return ob_get_clean() ."\n";
	}

	public static function fieldButton($param, $value, $options, $tab = "\t") {
		// init
		$img = isset($options['image']) ? "$tab{$options['images']}" : '';
		$name = isset($options['name']) ? $options['name'] : 'submit';
		$style = isset($options['style']) ? $options['style'] : '';
		$type = isset($options['type']) ? $options['type'] : 'submit';
		$title = isset($options['title']) ? defined($options['title']) ? constant($options['title']) : $options['title'] : '';
		$value = defined($value) ? constant($value) : $value;
		// build
		$button = "$tab<div class='text-center' style='$style'>\n"
						. $img
						. "$tab\t<input id='id_$param' type='$type' name='$name' class='btn btn-default' title='$title' value='$value'>\n"
						. "$tab</div>\n";
		// return
		return $button;
	}

	public static function fieldCheckbox($param, $value, $options, $tab = "\t") {
		$checked = $value ? ' checked' : '';
		$style = isset($options['style']) ? " style='{$options['style']}'" : '';
		$checkbox =	"$tab<div class='form-group $param' data-toggle='tooltip' title='". (defined($options['tooltip']) ? constant($options['tooltip']) : $options['tooltip']) ."'>\n"
							. "$tab\t<label for='$param' class='col-sm-5 control-label'>". constant($options['title']) ."</label>\n"
							. "$tab\t<div class='col-sm-4 form-checkbox'$style>\n"
							. "$tab\t\t<input type='hidden' name='data[$param]' value='0'>\n"
							. "$tab\t\t<input type='checkbox' name='data[$param]' id='id_$param' value='1'$checked>\n"
							. "$tab\t</div>\n"
							. (isset($options['third-column']) ? "$tab\t{$options['third-column']}\n" : "")
							. "$tab</div>\n";
		return $checkbox;
	}

	public static function fieldPorts($param, $lifs, $options, $tab = "") {
		$ports = 	"$tab<div class='form-group {$param}[]' style='{$options['style']}'>\n"
						.	"$tab\t<label for='{$param}[]' class='col-sm-3 control-label'>". (defined($options['label']) ? constant($options['label']) : $options['label']) ."</label>\n"
						. "$tab\t<div class='col-sm-8'>\n";
		foreach ($lifs as $key => $lif) {
			$ports .= "$tab\t\t<div class='left' style='margin-left:50px;'>\n"
							. "$tab\t\t\t<div><b>Li$key({$lif['type']})</b></div>\n"
							. "$tab\t\t\t<div>\n";
			foreach($lif['ports'] as $port) {
				$ports .= "$tab\t\t\t\t<div>Port $port <input type='checkbox' class='aport' name='data[$param][]' value='$port'></div>\n";
			}
			$ports .= "$tab\t\t\t</div>\n"
							.	"$tab\t\t</div>\n";
		}
		$ports .= "$tab\t</div>\n"
						.	"$tab</div>\n";
		return $ports;
	}

	public static function fieldSelect($param, $key_sel, $options, $tab = "\t") {
		// set selected field
		$selected[$key_sel] = ' selected';

  	$select = "$tab<div class='form-group $param' data-toggle='tooltip' title='". (defined($options['tooltip']) ? constant($options['tooltip']) : $options['tooltip']) ."'>\n"
  					. "$tab\t<label for='$param' class='col-sm-5 control-label'>". constant($options['title']) ."</label>\n"
  					. "$tab\t<div class='col-sm-4'>\n"
						. "$tab\t\t<select class='form-control input-sm' name='data[$param]' id='id_$param'>\n";

		foreach ($options['options']['select'] as $key => $value) {
			$select .= "$tab\t\t\t<option value='$key'{$selected[$key]}>". (defined($value) ? constant($value) : $value) ."</option>\n";
		}
                       
		$select .= "$tab\t\t</select>\n"
						.  "$tab\t</div>\n"
						.  "$tab</div>\n";
	
		return $select;
	}

	public static function fieldText($param, $value, $options, $tab = "\t") {
		$class = array(
			'input'			=> 'form-control input-sm',
			'input-div'	=> 'col-sm-4',
			'label'			=> 'col-sm-5 control-label',
			'main-div'	=> 'form-group',
		);
		if (!empty($options['class'])) {
			$class = array_merge($class, $options['class']);
		}
		$options['disabled'] = $options['disabled'] ? ' disabled' : '';
		$tooltip = defined($options['tooltip']) ? constant($options['tooltip']) : $options['tooltip'];
		$input =  "$tab<div class='{$class['main-div']} $param' data-toggle='tooltip' title='$tooltip'>\n"
						. "$tab\t<label for='$param' class='{$class['label']}'>". (defined($options['title']) ? constant($options['title']) : $options['title']) ."</label>\n"
         		. "$tab\t<div class='{$class['input-div']}' style='{$options['style-div']}'>\n"
       			. "$tab\t\t<input type='text' class='{$class['input']}' name='data[$param]' id='id_$param' value='$value' style='{$options['style-input']}'{$options['disabled']}>\n"
						. (isset($options['third-column']) ? $options['third-column'] : '')
       			. "$tab\t</div>\n"
       			. "$tab</div>\n";
		return $input;
	}

	public static function fieldText2($param, $value, $options, $tab = "\t") {
		$class = array(
			'input-1'		=> 'form-control input-sm',
			'input-2'		=> 'form-control input-sm',
			'input-div'	=> 'col-sm-4',
			'label'			=> 'col-sm-5 control-label',
			'main-div'	=> 'form-group',
		);
		if (!empty($options['class'])) {
			$class = array_merge($class, $options['class']);
		}
		// output
		$value = explode(';', $value);
		$input =  "$tab<div class='{$class['main-div']} $param' data-toggle='tooltip' title=''>\n"
						. "$tab\t<label for='$param' class='{$class['label']}'>". (defined($options['title']) ? constant($options['title']) : $options['title']) ."</label>\n"
         		. "$tab\t<div class='{$class['input-div']}'>\n"
       			. "$tab\t\t<input type='text' class='{$class['input-1']}' style='width:49%;display:inline-block;' name='data[$param][1]' id='id_{$param}_1' value='{$value[0]}' title='". constant($options['tooltip'][1]) ."' data-toggle='tooltip'>\n"
       			. "$tab\t\t<input type='text' class='{$class['input-2']}' style='width:49%;display:inline-block;' name='data[$param][2]' id='id_{$param}_2' value='{$value[1]}' title='". constant($options['tooltip'][2]) ."' data-toggle='tooltip'>\n"
       			. "$tab\t</div>\n"
       			. "$tab</div>\n";
		return $input;
	}

	public static function fieldUpload($param, $value, $options, $tab = "\t") {
		$upload = "$tab<div class='form-group'>\n"
						.	"$tab\t<label for='uploadfile' class='col-sm-5 control-label'>". constant($options['title']) ."</label>\n"
						. "$tab\t<div class='col-sm-4 form-checkbox'>\n"
						. "$tab\t\t<input type='file' size='28' name='$param'>\n"
						. "$tab\t</div>\n"
						. "$tab</div>\n";
		return $upload;
	}

	public static function inlineButtons($label, $btns, $tab = "\t") {
		$buttons = 	"$tab<div class='form-group'>\n"
							. "$tab\t<label for='download' class='col-sm-5 control-label'>". constant($label). "</label>\n"
							. "$tab\t<div class='col-sm-4'>\n";
		foreach ($btns as $btn) {
			$buttons .= "$tab\t\t<input type='button' class='btn btn-default' value='". constant($btn['value']). "' onclick=\"{$btn['javascript']}\">\n";
		}
		$buttons .= "$tab\t</div>\n"
							.	"$tab</div>\n";
		return $buttons;
	}

	public static function modalButton($options, $tab = "") {
		$btn = 	"$tab<div class='text-center'>\n"
					.	"$tab\t<a href='{$options['url-add']}' id='{$options['href-id']}' role='button' data-remote='false' data-toggle='modal' data-target='#{$options['modal-id']}' class='btn btn-default' style='color:#a31d26'>". constant($options['btn-add']) ."</a>\n"
					. "$tab</div>\n"
					. "$tab<div class='modal fade bs-example-modal-lg' id='{$options['modal-id']}' tabindex='-1' role='dialog' aria-labelledby='{$options['modal-id-title']}' aria-hidden='true'>\n"
					. "$tab\t<div class='modal-dialog modal-lg'>\n"
					. "$tab\t\t<div class='modal-content'>\n"
					. "$tab\t\t\t<div class='modal-header'>\n"
					. "$tab\t\t\t\t<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>\n"
					. "$tab\t\t\t\t<h4 class='modal-title' id='{$options['modal-id-title']}'>". constant($options['modal-title']) ."</h4>\n"
					. "$tab\t\t\t</div>\n"
					. "$tab\t\t\t<div class='modal-body'></div>\n"
					. "$tab\t\t</div>\n"
					. "$tab\t</div>\n"
					. "$tab</div>\n";
		ob_start();
		?>
		<script>
			$(document).ready(function () {
				$('#<?php echo $options['modal-id']; ?>').on('show.bs.modal', function(e) {
					var link = $(e.relatedTarget);
					$('.modal-body').load(link.attr('href'));
				});
				$('#<?php echo $options['modal-id']; ?>').on('hidden.bs.modal', function (e) { 
					$('.modal-body').empty(); 
				});
			});
		</script>
		<?php
		return $btn;
	}

	public static function section($id, $content, $options = array(), $tab = '') {
		$section =	"$tab<section id='$id'>\n"
							.	$content
							. "$tab</section>\n";
		return $section;
	}

	public static function tab($id, $form, $javascript, $content, $data_validate = array(), $tabulation = '') {
		$tab =	"$tabulation<!-- BEGIN TAB$id --!>\n"
					.	"$tabulation<div id='tabs-$id'>\n";
		if (isset($content['main-form'])) {
			$tab .=	"$tabulation\t<form id='{$form['id']}' name='{$form['name']}' action='modules/{$form['uri']}' class='form-horizontal' ENCTYPE='multipart/form-data' method='POST' style='{$form['style']}'>\n"
						. "$tabulation\t\t<input type='hidden' name='action' value='{$form['action']}'/>\n"
						. $content['main-form']
						. "$tabulation\t</form>\n";
		}
		$tab .= (isset($content['2nd-form']) ? $content['2nd-form'] : '')
					. ($form['has-required'] ? "$tabulation\t<div class='text-center' style='margin-top:20px;'><i>". REQUIRED_FIELDS ."</i></div>\n" : '')
					. (is_null($javascript) ? '' : $javascript)
					. (empty($data_validate) ? '' : self::validateJavascript($form, $data_validate))
					. "$tabulation</div>\n";
		return $tab;
	}

	public static function validateJavascript($form, $data_validate) {
		$java = '';
		foreach ($data_validate as $key => $params) {
			if (is_null($params['validator-java'])) {
				continue;
			}
			else if (is_array($params['validator-java'])) {
				foreach ($params['validator-java'] as $id => $validator) {
					$java .= "\t\t\t\t\t'data[$key][$id]': { $validator },\n";
				}
			}
			else if (isset($params['is-nodes'])) {
				$java .= "\t\t\t\t\t'data[$key][]': { {$params['validator-java']} },\n";
			}
			else {
				$java .= "\t\t\t\t\t'data[$key]': { {$params['validator-java']} },\n";
			}
		}
		return 	"\t<script>\n"
					.	"\t\t$(document).ready(function() {\n"
					. "\t\t\t$('#{$form['id']}').validate({\n"
					. "\t\t\t\trules: {\n"
					. $java
					. "\t\t\t\t}\n"
					. "\t\t\t});\n"
					. "\t\t});\n"
					. "\t</script>\n";
	}
}
